Tables <- function(t){
  ################################################
  ########## TABLE 1 #############################
  Table1 <- function(){

    lambdas <- c(rep(3, 8), rep(2, 8), rep(1, 8), rep(0.5, 8), rep(0.2, 8), rep(0.15, 8))
    n_s <- rep(c(25, 100, 400, 2500, 10000, 40000, 90000, 250000), 8)

    q_s <- lambdas / sqrt(n_s)

    Mixed_cdf_example <- function(x)
    {
      result <- 0
      if (x < 0){
        result <- 0
      }
      else if (x == 0){
        result <- 0.5
      }
      else if (x < log(2.5)){
        result <- 1 - 0.5 * exp(-x)
      }
      else{
        result <- 1
      }

      return (result)
    }

    for (i in 1 : length(lambdas)){
      ptm <- proc.time()

      print(KSgeneral::mixed_ks_c_cdf(q_s[i], n_s[i], c(0, log(2.5)), Mixed_cdf_example))

      print(proc.time() - ptm)

      i <- i + 1

    }

  }


  ##############################################################################
  ################# TABLE 2 ##################################
  Table2 <- function(){
    Mixed_cdf_example <- function(x)
    {
      result <- 0
      if (x < 0){
        result <- 0
      }
      else if (x == 0){
        result <- 0.5
      }
      else if (x < log(2.5)){
        result <- 1 - 0.5 * exp(-x)
      }
      else{
        result <- 1
      }

      return (result)
    }

    q_s <- c(0.25, 0.13, 0.065, 0.026, 0.013, 0.0065)
    n_s <- c(25, 100, 400, 2500, 10000, 40000)

    for (i in 1 : length(q_s)){
      ptm_1 <- proc.time()

      print(KSgeneral::mixed_ks_c_cdf(q_s[i], n_s[i], c(0, log(2.5)), Mixed_cdf_example))

      print(proc.time() - ptm_1)

      ptm_2 <- proc.time()

      print(KSgeneral::cont_ks_c_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm_2)

      i <- i + 1

    }


  }
  #########################################################################
  ################# TABLE 3 ###############################################
  Table3 <- function(){

    binom_3 <- stepfun(c(0:3), c(0,pbinom(0:3, 3, 0.5)))

    lambdas <- c(rep(3, 4), rep(2, 4), rep(1, 4), rep(0.5, 4), rep(0.2, 4), rep(0.1, 4))
    n_s <- rep(c(25, 400, 10000, 90000), 6)

    #    lambdas <- c(rep(1, 4), rep(0.5, 4), rep(0.2, 4), rep(0.1, 4))
    #    n_s <- rep(c(25, 400, 10000, 90000), 4)

    q_s <- lambdas / sqrt(n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::disc_ks_c_cdf(q_s[i], n_s[i], binom_3))

      print(proc.time() - ptm)

      i <- i + 1
    }
  }

  #########################################################################
  ################# TABLE 4 ###############################################
  Table4 <- function(){

    binom_7 <- stepfun(c(0:7), c(0,pbinom(0:7, 7, 0.5)))

    lambdas <- c(rep(3, 4), rep(2, 4), rep(1, 4), rep(0.5, 4), rep(0.2, 4), rep(0.1, 4))
    n_s <- rep(c(25, 400, 10000, 90000), 6)

    q_s <- lambdas / sqrt(n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::disc_ks_c_cdf(q_s[i], n_s[i], binom_7))

      print(proc.time() - ptm)

      i <- i + 1
    }
  }

  ##########################################################################
  ################# TABLE 5 ################################################
  Table5 <- function(){

    binom_15 <- stepfun(c(0:15), c(0,pbinom(0:15, 15, 0.5)))

    lambdas <- c(rep(3, 4), rep(2, 4), rep(1, 4), rep(0.5, 4), rep(0.2, 4), rep(0.1, 4))
    n_s <- rep(c(25, 400, 10000, 90000), 6)

    q_s <- lambdas / sqrt(n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::disc_ks_c_cdf(q_s[i], n_s[i], binom_15))

      print(proc.time() - ptm)

      i <- i + 1
    }
  }

  ##############################################################################
  ################# TABLE 6 ###############################################

  Table6 <- function()
  {
    unif_10 <- stepfun(c(1:10), c(0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0))
    q_s <- c(0.2, 0.2, 0.22, 0.2, 0.02, 0.0094, 0.0065, 0.00241)

    n_s <- c(25, 30, 50, 100, 1000, 5000, 10000, 100000)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::disc_ks_c_cdf(q_s[i], n_s[i], unif_10))
      #      print(KSgeneral::disc_ks_c_cdf(q_s[i], n_s[i], unif_10, exact = FALSE))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }
  #########################################################################
  ################## TABLE 8 ##############################################

  Table8 <- function(){
    n_s <- c(20, 40, 60, 80, 100, 120, 140)
    q_s <- 1 / n_s

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 9 ##############################################

  Table9 <- function(){
    n_s <- c(20, 40, 60, 80, 100, 120, 140)
    q_s <- sqrt(0.75 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 10 ##############################################

  Table10 <- function(){
    n_s <- c(20, 40, 60, 80, 100, 120, 140)
    q_s <- sqrt(0.76 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 11 #############################################

  Table11 <- function(){
    n_s <- c(20, 40, 60, 80, 100, 120, 140)
    q_s <- sqrt(3.9 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 12 #############################################

  Table12 <- function(){
    n_s <- c(20, 40, 60, 80, 100, 120, 140)
    q_s <- sqrt(4.1 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 13 #############################################

  Table13 <- function(){
    n_s <- c(20, 40, 60, 80, 100, 120, 140)
    q_s <- sqrt(12 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 14 #############################################

  Table14 <- function(){
    n_s <- c(140, 200, 500, 1000, 2000, 5000, 10000, 100000)
    q_s <- (1.3 / n_s)^(2 / 3)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 15 #############################################

  Table15 <- function(){
    n_s <- c(140, 500, 1000, 5000, 10000, 50000, 100000)
    q_s <- (1.4 / n_s)^(2 / 3)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 16 #############################################

  Table16 <- function(){
    n_s <- c(141, 500, 1000, 5000, 10000, 50000, 100000)
    q_s <- sqrt(10 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 17 #############################################

  Table17 <- function(){
    n_s <- 100001
    q_s <- c((1 / (10 * sqrt(n_s))), (1 / (8* sqrt(n_s))), (1 / (6 * sqrt(n_s))), (1 / (4 * sqrt(n_s))), (1 / (2 * sqrt(n_s))), (1 / (sqrt(n_s))), (2 / (sqrt(n_s))))

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_cdf(q_s[i], n_s))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 18 #############################################

  Table18 <- function(){
    n_s <- c(20, 40, 60, 80, 100, 120, 140)
    q_s <- sqrt(4 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_c_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 19 #############################################

  Table19 <- function(){
    n_s <- c(141, 500, 1000, 5000, 10000, 50000, 100000)
    q_s <- sqrt(2.1 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_c_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 20 #############################################

  Table20 <- function(){
    n_s <- c(141, 500, 1000, 10000, 100000)
    q_s <- sqrt(2.2 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_c_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 21 #############################################

  Table21 <- function(){
    n_s <- c(141, 500, 1000, 10000, 100000)
    q_s <- sqrt(7 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_c_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  ################## TABLE 22 #############################################

  Table22 <- function(){
    n_s <- c(100001, 200000, 300000)
    q_s <- sqrt(3 / n_s)

    for(i in 1:length(q_s)){
      ptm <- proc.time()

      print(KSgeneral::cont_ks_c_cdf(q_s[i], n_s[i]))

      print(proc.time() - ptm)

      i <- i + 1
    }

  }

  #########################################################################
  #########################################################################

  if (t == 1){
    Table1()
  }
  else if (t == 2){
    Table2()
  }
  else if (t == 3){
    Table3()
  }
  else if (t == 4){
    Table4()
  }
  else if (t == 5){
    Table5()
  }
  else if (t == 6){
    Table6()
  }
  else if (t == 8){
    Table8()
  }
  else if (t == 9){
    Table9()
  }
  else if (t == 10){
    Table10()
  }
  else if (t == 11){
    Table11()
  }
  else if (t == 12){
    Table12()
  }
  else if (t == 13){
    Table13()
  }
  else if (t == 14){
    Table14()
  }
  else if (t == 15){
    Table15()
  }
  else if (t == 16){
    Table16()
  }
  else if (t == 17){
    Table17()
  }
  else if (t == 18){
    Table18()
  }
  else if (t == 19){
    Table19()
  }
  else if (t == 20){
    Table20()
  }
  else if (t == 21){
    Table21()
  }
  else if (t == 22){
    Table22()
  }

}

